﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using DataTables.AspNetCore.Mvc
@model CyberaniumModels.ThreatEnabler
@{
    ViewData["Title"] = "Index";
    //Layout = "~/Views/Shared/_Layout.cshtml";
}
<style>
    .note-toolbar .btn-group, .note-toolbar .btn-group .btn {
        width: inherit !important;
    }

    .adddivProcess {
        padding-left: 20px;
    }

    .modal.fade .modal-dialog {
        transform: translate(0,0);
        min-width: 1200px;
    }

    tr td:first-child {
        text-align: left;
    }
</style>
<script src="~/Script/Master/Layout.js"></script>
<script>
    $(document).ready(function () {
        $('.multiple').multiselect({
            enableFiltering: true,
            includeSelectAllOption: true
        });
        if ($("#Id").val() > 0) {
            $(".titile_heading h1").html("Add Threat Enabler");
            $(".service_line").addClass("active");
            $(".assign_panel").hide();
            $(".titile_heading").show();
            $("#accordionExample").html($("#FormHtml").val());
} else {
    $(".titile_heading h1").html("Threat Probability Score");
    $(".service_line").removeClass("active");
    $(".assign_panel").show();
    $(".titile_heading").show();
}
})
function hideForm() {
$('#reset').click();
$('#dvDataTable').show();
$('.service_line').hide();
$('#dvForm').attr('class', 'service_line');
}
function manageCheckbox(checkbox) {
var isChecked = $(checkbox).is(':Checked');
var id = $(checkbox).val();
if (isChecked) {
    $('#table_' + id).find('input').prop('checked', true);
} else {
    $('#table_' + id).find('input').prop('checked', false);
}
}
function fn_ShowPopoup() {
$("#tblThreads thead").empty();
$("#tblThreads tbody").empty();
var thead = '<tr>', tbody = '<tr>';
var childOrgId = $("#ChildOrg").val() == '' ? 0 : $("#ChildOrg").val();
var IsParent = $("#rdParent").val();
var IsChild = $("#rdChild").val();
if ($("#rdChild").prop("checked") && $("#ChildOrg").val() <= 0) {
    toastr.error('Please select child organization name');
} else {
    $.post('/ApplicationManagement/ThreatEnabler/GetChildOrgControlCategory', { ChilOrgID: childOrgId, OrgID: $("#Id").val() }, function (res) {
        debugger;
        $.each(res.enums, function (i, item) {
            thead += '<th> &nbsp;<input type="checkbox" checked value="' + item.value + '" onclick="manageCheckbox(this)">&nbsp;' + item.name + '</th>';
            tbody += '<td class="m-0 p-0" id="td_' + item.value + '"></td>';
            $.get('/Master/Threat/GetThreatsByControlCategoryId', { controlCategoryId: item.value }, function (data) {
                debugger;
                var table = '<table class="table table-striped m-0 p-0" id="table_' + item.value + '"><tbody>';
                if (data.length > 0) {
                    $.each(data, function (i, val) {
                        var title = val.threatCode + ' - ' + val.threatName;
                        table += '<tr><td><input type="checkbox" checked value="' + val.threatId + '">&nbsp;' + title + '</td></tr>';
                    })
                }
                table += '</tbody></table>';
                setTimeout(function () {
                    $('#td_' + item.value).html(table);
                }, 500);
            })
        })
        thead += '</tr>';
        tbody += '</tr>';
        $("#tblThreads thead").html(thead);
        $("#tblThreads tbody").html(tbody);
        $("#exampleModalCenter").modal('show');
    })
}
}
function fn_SaveEnablerThreads() {
$("#exampleModalCenter").modal('hide');
var html = '';
var ChildOrgId = $("#ChildOrg").val();
var OrganizationId = $("#Id").val();
if (ChildOrgId == "" || ChildOrgId == null) {
    ChildOrgId = 0;
}
$('#tblThreads thead tr th').each(function (iTh, th) {
    var conCatId = $(th).find('input').val();
    var conCatName = $(th).text();
    var tbody = '';
    var thead = '<th>Threats</th>';
    var inputs = '';
    $.ajax({
        url: "/ApplicationManagement/ThreatEnabler/GetFirstQuesAnswersByConCatId",
        type: "POST",
        async: false,
        data: { controlCategoryId: conCatId, ChildOrgId: ChildOrgId, OrganizationId: OrganizationId },
        success: function (res) {
            $.each(res, function (i, val) {
                thead += '<th>' + val.answer + '</th>';
                inputs += '<td><input class="form-control" type="number" min="1" max="5" name="App_' + val.value + '" onchange="validateInput(this)" /></td>';
            })
            $('#table_' + conCatId + ' tbody tr').each(function (iTr, tr) {
                var threatName = $(tr).find('td').text();
                var threatId = $(tr).find('td input').val();
                var isChecked = $(tr).find('td input').is(':checked');
                tbody += isChecked ? '<tr><td><input type="hidden" value="' + threatId + '">' + threatName + '</td>' + inputs + '</tr>' : '';
            });
            html += '<div class="card">' +
                '<div class="card-header" id="ConCat_' + conCatId + '">' +
                '<h2 class="mb-0">' +
                '<button class="btn btn-link" type="button" data-toggle="collapse" data-target="#collapse_' + conCatId + '" aria-expanded="true" aria-controls="collapse_' + conCatId + '">' + conCatName + '</button>' +
                '</h2>' +
                '</div>' +
                '<div id="collapse_' + conCatId + '" class="undefined collapse show" aria-labelledby="ConCat_' + conCatId + '" data-parent="#accordionExample" style="">' +
                '<div class="card-body">' +
                '<table class="table table-striped tblControlCategory" id="conCatTable_' + conCatId + '">' +
                '<thead class="bg-primary"><tr>' + thead + '</tr></thead>' +
                '<tbody>' + tbody + '</tbody>' +
                '</table>' +
                '</div>' +
                '</div>' +
                '</div>';
        },
        error: function (ex) {
            console.log(ex.responseText);
        }
    })

    //    $.get('/ApplicationManagement/ThreatEnabler/GetFirstQuesAnswersByConCatId', { controlCategoryId: conCatId, ChildOrgId: ChildOrgId, OrganizationId: OrganizationId }, function (res) {
    //        debugger;
    //        $.each(res, function (i, val) {
    //            thead += '<th>' + val.answer + '</th>';
    //            inputs += '<td><input class="form-control" type="number" min="1" max="5" name="App_' + val.value + '" onchange="validateInput(this)" /></td>';
    //        })
    //        $('#table_' + conCatId + ' tbody tr').each(function (iTr, tr) {
    //            var threatName = $(tr).find('td').text();
    //            var threatId = $(tr).find('td input').val();
    //            var isChecked = $(tr).find('td input').is(':checked');
    //            tbody += isChecked ? '<tr><td><input type="hidden" value="' + threatId + '">' + threatName + '</td>' + inputs + '</tr>' : '';
    //        });
    //        html += '<div class="card">' +
    //            '<div class="card-header" id="ConCat_' + conCatId + '">' +
    //            '<h2 class="mb-0">' +
    //            '<button class="btn btn-link" type="button" data-toggle="collapse" data-target="#collapse_' + conCatId + '" aria-expanded="true" aria-controls="collapse_' + conCatId + '">' + conCatName + '</button>' +
    //            '</h2>' +
    //            '</div>' +
    //            '<div id="collapse_' + conCatId + '" class="undefined collapse show" aria-labelledby="ConCat_' + conCatId + '" data-parent="#accordionExample" style="">' +
    //            '<div class="card-body">' +
    //            '<table class="table table-striped tblControlCategory" id="conCatTable_' + conCatId + '">' +
    //            '<thead class="bg-primary"><tr>' + thead + '</tr></thead>' +
    //            '<tbody>' + tbody + '</tbody>' +
    //            '</table>' +
    //            '</div>' +
    //            '</div>' +
    //            '</div>';
    //    })
});
$("#accordionExample").html(html);
$("#accordionExample").show();
//    setTimeout(function () {
//        $("#accordionExample").html(html);
//        $("#accordionExample").show();
//    }, 500);
}
function validateInput(input) {
var val = parseInt($(input).val());
if (val < 1 || val > 5) {
    toastr.warning('Score should be between 1 to 5.');
    $(input).val('');
}
}
function fn_ShowPopoup1() {
debugger
$("#tblThreads tbody").empty();
var html = "";
var count = $("#tblThreads thead tr td").length;
count = (count - 1);
if ($("#ChildOrg").val() > 0) {
    $.ajax({
        url: "/ApplicationManagement/ThreatEnabler/ThreadList",
        type: "POST",
        cache: false,
        data: {},
        success: function (result) {
            debugger
            for (let t = 0; t < count; count--) {
                html = html + "<td style='text-align:center'><input type='checkbox'></td>";
            }
            $.each(result, function (i, value) {
                debugger
                $("#tblThreads tbody").append("<tr><td hidden>" + value.threatId + "</td><td>" + value.codeName + "</td>" + html + "</tr>");
            });
            $("#exampleModalCenter").modal('show');
        },
        error: function (ex) {
            console.log(ex.responseText);
        }
    });
} else {
    alert('Please select child organizaion first');
}
}
function fn_GetChildOrgControlCategory() {
debugger;
var ChilOrgID = $("#ChildOrg").val() == '' ? 0 : $("#ChildOrg").val();
$("#tblThreads thead").empty();
$("#accordionExample").empty();
$("#accordionExample").hide();
var html = "<tr><td style='width:50%'>Threat Enabler</td>";
$.ajax({
    url: "/ApplicationManagement/ThreatEnabler/GetChildOrgControlCategory",
    type: "POST",
    cache: false,
    data: { ChilOrgID: ChilOrgID, OrgID: $("#Id").val() },
    success: function (result) {
        debugger
        $.each(result.enums, function (i, value) {
            var html2 = "";
            var html3 = "";
            var FT;
            var CC;
            if (i == 0) {
                FT = true;
                CC = 'show';
            } else {
                FT = false;
            }
            html3 = html3 + "<table class='table table-striped table-responsive' id='Table_" + value.value + "'>";
            html3 = html3 + "<thead class='bg-primary'><tr><th hidden></th><th>Threats</th>";
            $.each(result.arrList, function (j, value2) {
                if (value.value == value2.value) {
                    html2 = html2 + value2.title;
                }
            });
            html3 = html3 + html2;
            html3 = html3 + "</tr></thead><tbody>";
            html3 = html3 + "</tbody></table>";
            html = html + "<td style='text-align:center'>" + value.name + "&nbsp;<input type='checkbox' onclick='fn_CheckedAll(" + i + ",this" + ")' value=" + value.value + " style='padding-left:10px' id='" + i + "'/></td>";
            $("#accordionExample").append("<div class='card'><div class='card-header' id=" + value.name + ">" +
                "<h2 class='mb-0'><button class='btn btn-link' type='button' data-toggle='collapse' data-target='#collapse" + value.name + "' aria-expanded=" + FT + " aria-controls='collapse" + value.name + "'>" + value.name + "</button></h2></div>" +
                "<div id='collapse" + value.name + "' class='collapse " + CC + "' aria-labelledby=" + value.name + " data-parent='#accordionExample'>" +
                "<div class='card-body'>" + html3 + "</div></div></div> ");
        });
        html = html + "</tr>";
        $("#tblThreads thead").append(html);
    },
    error: function (ex) {
        console.log(ex.responseText);
    }
});
}
function fn_SaveEnablerThreads1() {
debugger
$("#accordionExample").show();
$("#exampleModalCenter").modal('hide');
$('#tblThreads thead tr td').each(function (i, td) {
    debugger
    var value = $(td).find("input[type=checkbox]").val();
    var R = $(td).find("input[type=checkbox]").attr('Id');
    R = parseInt(R) + parseInt(3);
    if (value != undefined && value > 0) {
        $('#tblThreads tbody tr').each(function (i, tr) {
            var html = "";
            var cntt = $("#Table_" + value + " thead tr th").length - 1;
            if ($(tr).find("td:nth-child(" + R + ") input[type=checkbox]").is(":checked")) {
                var ThreadName = $(tr).find("td:nth-child(2)").text();
                var ThreadID = $(tr).find("td:nth-child(1)").text();
                html = html + "<tr><td hidden>" + ThreadID + "</td><td><input type='text' class='form-control' disabled style='width:500px' value='" + ThreadName + "' /></td>";
                for (let t = 1; t < cntt; cntt--) {
                    html = html + "<td><input type='number' class='form-control' onchange='fn_ValidateNumber(this)'></td>";
                }
                html = html + "</tr>";
                $("#Table_" + value + " tbody").append(html);
            }
        });
    }
});
}

function fn_CheckedAll(R, input) {
debugger
R = R + 3;
var isChecked = $(input).prop("checked");
$('#tblThreads tbody tr').each(function (i, tr) {
    debugger;
    $(tr).find("td:nth-child(" + R + ") input[type=checkbox]").prop("checked", isChecked);
});
}
function fn_ValidateNumber(input) {
if ($(input).val() > 5) {
    $(input).val('');
}
}
function SaveEnablerThreats() {
debugger
$('#preloader').show();
var QuestionnaireXML = [];

$('#accordionExample table').each(function (i, table) {
    var CategoryId = parseInt($(table).attr('id').split('_')[1]);
    var QuesArray = [], iQues = 0;
    var tablename = "#" + $(table).attr('id') + " tbody tr";
    var tablename2 = "#" + $(table).attr('id') + " thead tr";

    debugger;

    var loop = $(table).find('thead tr:eq(0) th').length;
    $(tablename).each(function (k, tr) {
        debugger;
        var p = 0;
        var AnsArray = [];
        var ThreatID = ($(tr).find("td:nth-child(1)")).text();
        for (q = 3; q <= loop; q++) {
            if (ThreatID == undefined) { return; }
            AnsArray[p] = {
                Score: ($(tr).find("td:nth-child(" + q + ") input[type=text]")).val(),
                AppID: ($(tablename2).find("th:nth-child(" + q + ")")).attr('id'),
                ThreatsID: ThreatID,
                uniqueId: k + 1,
            }
            p++;
        }
        debugger;

        QuesArray[k] = {
            uniqueId: k + 1,
            AnsArray: AnsArray
        }

    });
    QuestionnaireXML[i] = {
        CategoryId: CategoryId,
        QuesArray: QuesArray
    }
});
var model = {
    Id: $("#Id").val(),
    ChildOrg: parseInt($('#ChildOrg').val()),
    QuestionnaireXML: JSON.stringify(QuestionnaireXML),
}
$.post('/ApplicationManagement/ThreatEnabler/SubmitThreatsEnabler', { model: model }, function (res) {
    $('#preloader').hide();
});
}

function prepareXMLForSave() {
var enablerXML = [], threatScoreXML = [], sn = 0;
$('.tblControlCategory').each(function (i, table) {
    var conCatId = parseInt($(table).attr('id').split('_')[1]);
    enablerXML[i] = {
        ConCatId: conCatId
    }
    $(table).find('tbody tr').each(function (trI, tr) {
        var threatId = 0;
        $(tr).find('td').each(function (tdI, td) {
            if (tdI == 0) {
                threatId = parseInt($(td).find('input').val());
            } else {
                var questionnaireMapId = parseInt($(td).find('input').attr('name').split('_')[1]);
                var score = parseInt($(td).find('input').val());
                threatScoreXML[sn] = {
                    ConCatId: conCatId,
                    ThreatId: threatId,
                    QuestionnaireMapId: questionnaireMapId,
                    Score: score
                }
                sn++;
            }
        })
    })
})
var model = {
    ParentOrgId: parseInt($("#Id").val()),
    ChildOrgId: parseInt($("#ChildOrg").val()),
    EnablerXML: JSON.stringify(enablerXML),
    ThreatScoreXML: JSON.stringify(threatScoreXML)
}
$.post('/ApplicationManagement/ThreatEnabler/SubmitThreatEnablerScore', { model: model }, function (res) {
    $('a[href="/ApplicationManagement/ThreatEnabler/Index"]').click();
    res.isSuccess ? toastr.success('Saved successfully.') : toastr.error('Something went wrong!');
})
}
function ManageOrganizationDiv(checkbox) {
var val = parseInt($(checkbox).val());
if (val > 0) {
    $('#divChildOrg').show();
    $('#ChildOrg').find('option:eq(0)').prop('selected', true);
} else {
    $('#divChildOrg').hide();
    $('#ChildOrg').find('option:eq(0)').prop('selected', true);
    //    fn_ShowPopoup()
}
}
</script>


<section>
    <input data-val="true" data-val-number="The field ServiceId must be a number." data-val-required="The ServiceId field is required." id="ServiceId" name="ServiceId" type="hidden" value="0">
    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Threat Probability Score</h1>
            <div class="titile_line"></div>
        </div>
        @if (ViewBag.message != null)
        {
            <script>toastr.success('@ViewBag.message')</script>
        }
        @if (ViewBag.error != null)
        {
            <script>toastr.error('@ViewBag.error')</script>
        }
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="service_line">
                        <form data-ajax="true"
                              data-ajax-method="POST"
                              data-ajax-mode="replace"
                              data-loading-text="loading......"
                              data-ajax-update="#ajaxresult"
                              data-ajax-success="fn_Onsuccess(data,'ApplicationManagement/ThreatEnabler/Index');"
                              data-ajax-failure="Errmsg(data);">
                            @Html.HiddenFor(m => m.Id)
                            @Html.HiddenFor(m => m.ArrList)
                            @Html.HiddenFor(m => m.QuestionnaireXML)
                            @Html.HiddenFor(m => m.FormHtml)
                            <div class="pb-2 mt-4 mb-2 border-bottom box_title">
                                Threat Probability Score
                            </div>
                            <div class="row">
                                <div class="col-12 text-center">
                                    <label>Select Organization Type</label>
                                    <div class="select_box m_bottom">
                                        <label class="col-6 text-right pr-2">
                                            <input type="radio" name="Organization" value="0" id="rdParent" onclick="ManageOrganizationDiv(this)">  Parent Organization
                                        </label>
                                        <label class="col-6 text-left pl-2">
                                            <input type="radio" name="Organization" id="rdChild" value="1" onclick="ManageOrganizationDiv(this)" checked>  Child Organization
                                        </label>
                                    </div>
                                </div>
                            </div>
                            <div class="mb-2 border-bottom box_title"></div>
                            <div class="row">
                                <div class="col-10">
                                    <div class="row pl-2">
                                        <div class="col-6" id="divChildOrg">
                                            @*@Html.DropDownListFor(m => m.ChildOrg, Model.ParentOrgDDL, "Select", new { @class = "form-control m_no" })*@
                                            @Html.DropDownListFor(m => m.ChildOrg, Model.ParentOrgDDL, "Select", new { @class = "form-control m_no", @onchange = "fn_GetChildOrgControlCategory(this)" })
                                        </div>
                                        <div class="col-3">
                                            <div class="submitbtn">
                                                <input type="button" value="Add" onclick="fn_ShowPopoup();" />
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="accordion pt-3" id="accordionExample">

                            </div>

                            <div class="row pt-3">
                                <div class="col-md-12 col-sm-12 col-xs-12">
                                    <div class="back_btn mt5" id="viewbutton">
                                        <div class="back_btn_in" data-title="Back">
                                            <input type="button" name="Back" onclick="hideForm()" value="Back">
                                        </div>
                                    </div>
                                    <div class="submitbtn mt5">
                                        <input type="button" id="btnsubmit" name="Submit" value="Submit" onclick="prepareXMLForSave()">
                                        @*<input type="submit" id="btnsubmit" name="Submit" value="Submit" onclick="SaveEnablerThreats()">*@
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>

                    <div class="assign_panel assign_section" id="dvDataTable">
                        <div class="assign_box active_block fade in">
                            <div class="row">
                                <div class="table_control">
                                    <table id="example2" class="table table-bordered table-hover">
                                        <thead>
                                            <tr>
                                                <th style="width:70px">SN</th>
                                                <th>Assigned Organization</th>
                                                <th style="width:130px">Action</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @{int sn = 0;}
                                            @foreach (var item in Model.OrganizationsList)
                                            {
                                                <tr>
                                                    <td>@(++sn)</td>
                                                    <td>@item.ParentOrgName</td>
                                                    <td>
                                                        <a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="Index" asp-route-Id="@item.Id" asp-route-ParentOrgName="@item.ParentOrgName" asp-controller="ThreatEnabler" asp-area="ApplicationManagement" class="edit_btn"></a>
                                                        @*<a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="BlockDeleteOrganization" asp-route-Id="@item.Id" asp-route-Type="0" asp-controller="Organization" asp-area="ApplicationManagement" class="Active_btn" asp-route-ActionName="@(item.IsActive ? "InActive" : "Active")"></a>*@
                                                        @*<a class="delete_btn" onclick="Confirmation('@item.Id')"></a>*@
                                                    </td>
                                                </tr>
                                            }
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>


<div class="modal fade" id="exampleModalCenter" tabindex="-1" role="dialog" aria-labelledby="exampleModalScrollableTitle" aria-hidden="true">
    <div class="modal-dialog modal-dialog-scrollable modal-dialog-centered modal-lg" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h3 class="modal-title" id="exampleModalScrollableTitle">Add Threat</h3>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <table class="table table-striped" id="tblThreads">
                    <thead class="bg-primary">
                    </thead>
                    <tbody>
                    </tbody>
                </table>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                <input type="button" class="btn btn-primary" onclick="fn_SaveEnablerThreads()" value="Submit" />
            </div>
        </div>
    </div>
</div>

